//import java.util.Random;

public class exPilha {

 // public exPilha() {} // implicito
 public static void main(String args[]) {
   testaPilha tp = new testaPilha();
   }

}

class Pilha { // Pilha de objetos genricos
  static int Limite;
  private int topo;
  private Object [] elementos; // classe de objetos genricos

  public Pilha(int lim) {
    Limite = lim;
    elementos = new Object[Limite];
    topo = -1;
  }
  
  public Object remove() {
    Object x=null; // default: null => pilha vazia
    if (topo > -1) {
       x = elementos[topo];
       topo--;
    }
    else System.out.println("Pilha vazia");
    return x;
  }

  public void insere (Object novo){
    if (topo < Limite) {
       topo++;
       elementos[topo] = novo;
    }
    else System.out.println("Pilha cheia ("+Limite+")");
  }

  public int topo() {
    return topo;
  }

  public Object elemento(int i) {
    if (i>=0 && i<=topo)
       return elementos[i];
    else return null;
  }

}

class pilhaInt extends Pilha { // Pilha de inteiros
    int val;
    pilhaInt( int lim ) {
	super(lim);
    }
    //- Se quiser sobrecarregar os mtodos ou especificar tipo
    //- public void insere(int x) {
    //-   super.insere( new Integer(x));
    //-   }
    //- public int removeInt() {
    //-   Object ob = remove();
    //-   return ((Integer)ob).intValue();
    //-   }
    //- public int elementoInt(int i) {
    //-   Object ob = elemento(i);
    //-   return ((Integer)ob).intValue();
    //-   }
}


class testaPilha {
  
  static int DifNum = 10;
  static int Total = 20;

  String [] msg = {"insere","remove"};

  public testaPilha() {
    int i,j,T=Total,op;
    java.util.Random r = new java.util.Random(DifNum);

    pilhaInt P = new pilhaInt(Total);

    System.out.println("\n\nIncio\n");

    for (i=0; i<T; i++) {
	Object g;
	op = java.lang.Math.abs( r.nextInt() );
	op %= 2; // Operacao: 0  inserir, 1  remover
	if (op==0) {
          //- j = java.lang.Math.abs( r.nextInt() )%100;
  	  //- P.insere(j);
          g = new Integer( java.lang.Math.abs( r.nextInt() )%100 );
  	  P.insere(g);
          }
        //- else j=P.removeInt();
        else g = P.remove();

      //- System.out.println("Operacao: "+msg[op]+" Elemento: "+j);
      System.out.println("Operacao: "+msg[op]+" Elemento: "+g);
      }
    Imprime( P );
    System.out.println( P.remove() ); // remove mais, diretamente da classe Pilha
    }

    private static void Imprime(pilhaInt P) {
      int i;
      System.out.println("topo="+P.topo());
      for (i=0; i<=P.topo(); i++)
          //- System.out.print(P.elementoInt(i) + " - ");
          System.out.print(P.elemento(i) + " - ");
      System.out.println();
    }
}
